public class StringVisitor implements Visitor {
    String s = "";

    StringVisitor() {}

    public void visit(Op o)
    {
        switch (o.kind) {
        case ADD:
            o.arg[0].visit(this);
            s += " + ";
            o.arg[1].visit(this);
            break;

        case SUB:
            o.arg[0].visit(this);
            s += " - ";
            o.arg[1].visit(this);
            break;

        case MUL:
            o.arg[0].visit(this);
            s += " * ";
            o.arg[1].visit(this);
            break;

        case DIV:
            o.arg[0].visit(this);
            s += " / ";
            o.arg[1].visit(this);
            break;

        case RAND:
            s += "rand(";
            o.arg[0].visit(this);
            s += ",";
            o.arg[1].visit(this);
            s += ")";
            break;
        }
    }

    public void visit(Ident x)
    {
        s += x.name;
    }

    public void visit(Float x)
    {
        s += Double.toString(x.value);
    }

    public void visit(Assign a)
    {
        s += a.var + " = ";
        a.expr.visit(this);
    }

    public void visit(Seq seq)
    {
        seq.p1.visit(this);
        s += ";\n";
        seq.p2.visit(this);
    }

    public void visit(If i)
    {
        s += "if ";
        i.cond.visit(this);
        s += " then ";
        i.pthen.visit(this);
        s += " else ";
        i.pelse.visit(this);
    }

    String result()
    {
        return s;
    }
}
